' A DataGridTextBoxColumn class that colors text box cells
' hot pink if their value is less than a given value.
Public Class ColoredTextBoxColumn
    Inherits DataGridTextBoxColumn

    Private m_Cutoff As Single = 0
    Public Sub New(ByVal cutoff As Single)
        m_Cutoff = cutoff
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As Graphics, ByVal bounds As Rectangle, ByVal source As CurrencyManager, ByVal rowNum As Integer, ByVal foreBrush As Brush, ByVal backBrush As Brush, ByVal alignToRight As Boolean)
        ' Get the cell's value.
        Dim cell_object As Object
        cell_object = Me.GetColumnValueAtRow(source, rowNum)

        ' If the value is numeric, get its value.
        Dim cell_number As Single = m_Cutoff - 1
        If IsNumeric(cell_object) Then
            cell_number = CType(cell_object, Single)
        End If

        ' Pick appropriate colors.
        If (cell_number < m_Cutoff) Then
            backBrush = Brushes.Pink
            foreBrush = Brushes.Red
        Else
            backBrush = Brushes.White
            foreBrush = Brushes.Black
        End If

        ' Draw the cell.
        MyBase.Paint(g, bounds, source, rowNum, backBrush, foreBrush, alignToRight)
    End Sub
End Class
